//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%407EAC5E02AD.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%407EAC5E02AD.cm

//## begin module%407EAC5E02AD.cp preserve=no
//## end module%407EAC5E02AD.cp

//## Module: TclRedAlert%407EAC5E02AD; Package body
//## Subsystem: XSUser::UserInterface%3804B6846530
//	/local/data/verisB/dorman/Xspec/src/userint
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUser/UserInterface/TclRedAlert.cxx

//## begin module%407EAC5E02AD.additionalIncludes preserve=no
//## end module%407EAC5E02AD.additionalIncludes

//## begin module%407EAC5E02AD.includes preserve=yes
#include <XSUser/UserInterface/xstcl.h>
#include <iostream>
#include <cstdlib>
//## end module%407EAC5E02AD.includes

// TclRedAlert
#include <XSUser/UserInterface/TclRedAlert.h>//## begin module%407EAC5E02AD.declarations preserve=no
//## end module%407EAC5E02AD.declarations

//## begin module%407EAC5E02AD.additionalDeclarations preserve=yes
// This is declared w/ extern in xstcl.h
Tcl_Interp* interp = 0;
//## end module%407EAC5E02AD.additionalDeclarations


// Class TclRedAlert 

TclRedAlert::TclRedAlert (const std::string& message, int returnCode)
  //## begin TclRedAlert::TclRedAlert%407EB2C30149.hasinit preserve=yes
  : RedAlert(message)
  //## end TclRedAlert::TclRedAlert%407EB2C30149.hasinit
  //## begin TclRedAlert::TclRedAlert%407EB2C30149.initialization preserve=yes
  //## end TclRedAlert::TclRedAlert%407EB2C30149.initialization
{
  //## begin TclRedAlert::TclRedAlert%407EB2C30149.body preserve=yes
  reportAndExit(message,returnCode);
  //## end TclRedAlert::TclRedAlert%407EB2C30149.body
}



//## Other Operations (implementation)
void TclRedAlert::reportAndExit (const std::string& message, const int returnCode)
{
  //## begin TclRedAlert::reportAndExit%407EB569029E.body preserve=yes
    // use the global tcl interp pointer to communicate with tcl,
  // and shut down xspec with the tcl exit command. The point is 
  // to delegate most of the cleanup work if any to the tcl library.
  
  // xspec renames tcl's exit command to tclexit. We don't want to
  // call the renamed version, which prompts the user whether they
  // actually want to exit, on a redAlert error. But we do need to
  // check whether the exception has been raised before or after the
  // renaming is done.
  std::cerr << "\n*** XSPEC Fatal Error " << message << std::endl;
  
  // check whether this exception is thrown before or after the tcl interface
  // has started. If before, simply print message and exit with a return code.
  // if after, use tcl's exit call to shut down. Need to check whether exit
  // has been renamed (to tclexit) or not, which is done in Xspec_Init.
  if ( interp )
  {
        Tcl_CmdInfo* infoPtr = new Tcl_CmdInfo;
        char* retStr = new char[4];
        const string ex = "tclexit ";
        sprintf(retStr,"%3d",returnCode);
        int status = Tcl_GetCommandInfo(interp, const_cast<char*>(ex.c_str()), infoPtr);
  
        string exitCommand = "";
   
        if (!status) exitCommand = ex  + string(retStr);
        else exitCommand = "exit " + string(retStr);
  
        Tcl_Eval(interp,const_cast<char*>(exitCommand.c_str())); 
   }
   else exit(returnCode); 
        
  //## end TclRedAlert::reportAndExit%407EB569029E.body
}

// Class TclInitErr 

TclInitErr::TclInitErr (const string& message, const int returnCode)
  //## begin TclInitErr::TclInitErr%928353400001.hasinit preserve=yes
  : TclRedAlert(message,returnCode)
  //## end TclInitErr::TclInitErr%928353400001.hasinit
  //## begin TclInitErr::TclInitErr%928353400001.initialization preserve=yes
  //## end TclInitErr::TclInitErr%928353400001.initialization
{
  //## begin TclInitErr::TclInitErr%928353400001.body preserve=yes
  //## end TclInitErr::TclInitErr%928353400001.body
}


//## begin module%407EAC5E02AD.epilog preserve=yes
//## end module%407EAC5E02AD.epilog
